Rep2 = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0")
Rep2:RegisterDB("Rep2DB","Rep2DBPerChar")
Rep2:RegisterDefaults("profile", {
	frame = 1,
	} )
function Rep2:OnInitialize()
end
local factionVars = { }
local colors = {
	white = "|cffffffff",
	yellow = "|cffffff78",
	orange = "|cffff7831",
}


function Rep2:OnEnable()
self:RegisterEvent("MEETINGSTONE_CHANGED","ScanFaction")
self:ScanFaction()
end

function Rep2:OnDisable()
end
local options = {
		type = "group",
		desc = "Displays reputation gains.",
		args = {
			set = {
				type = "text",
				name = "set",
				desc = "Set the output chatframe.",
				get = "GetChatFrame",
				set = "SetChatFrame",
				usage = "ChatFrame#",
				},
			},
		}
function Rep2:GetChatFrame()
	return self.db.profile.frame
end

Rep2:RegisterChatCommand({"/rep2","/r2"},options)
function Rep2:SetChatFrame(frameNum)
	frameNum = tonumber(frameNum)
	if type(frameNum) == "number" then
		if getglobal("ChatFrame"..frameNum) then
			self:Print("Now using ChatFrame"..frameNum)
			getglobal("ChatFrame"..frameNum):AddMessage(colors.yellow.."Rep2: "..colors.white.."Using this chat frame for reputation messages now!")	
			self.db.profile.frame = frameNum;
--			self:Print("Set "..self.db.profile.frame );
		else
			self:Print("ChatFrame"..frameNum.." is not a valid ChatFrame!")
		end
	end
end

function Rep2:UPDATE_FACTION()
	for factionIndex=1, GetNumFactions(), 1 do
		local name, _, standingID, barMin, barMax, barValue, _, _, isHeader, _ = GetFactionInfo(factionIndex)
        if not isHeader then
			if factionVars[name] then
				local diff = barValue - factionVars[name].Value
				if diff > 0 and standingID ~= 8 then
					if standingID ~= factionVars[name].Standing then
							getglobal("ChatFrame"..self.db.profile.frame):AddMessage("New standing with "..colors.yellow..name.." |ris "..colors.yellow..getglobal("FACTION_STANDING_LABEL"..standingID).."|r!")
					end
					local reps = math.ceil((barMax-barValue)/(barValue - factionVars[name].Value))
					getglobal("ChatFrame"..self.db.profile.frame):AddMessage(colors.orange.."+"..barValue - factionVars[name].Value..colors.yellow.." "..name.."|r, "..colors.orange..barMax - barValue.."|r more to "..colors.yellow..getglobal("FACTION_STANDING_LABEL"..standingID+1).."|r ("..colors.orange..reps.."|r Repetitions).")
					elseif diff < 0 and standingID ~= 1 then
					if standingID ~= factionVars[name].Standing then
						getglobal("ChatFrame"..self.db.profile.frame):AddMessage("New standing with "..colors.yellow..name.." |ris "..colors.yellow..getglobal("FACTION_STANDING_LABEL"..standingID).."|r!")
					end
					local reps = math.ceil((factionVars[name].Value - barValue)/(abs(barValue- barMin)))
					getglobal("ChatFrame"..self.db.profile.frame):AddMessage(colors.orange.."-"..factionVars[name].Value - barValue..colors.yellow.." "..name.."|r, "..colors.orange..abs(barValue- barMin).."|r more to "..colors.yellow..getglobal("FACTION_STANDING_LABEL"..standingID-1).."|r ("..colors.orange..reps.."|r Repetitions).")
				
				end
				factionVars[name].Value = barValue
				factionVars[name].Standing = standingID
			end
		end
	end
end

function Rep2:ScanFaction()
	for i=1, GetNumFactions(), 1 do
		local name, _, standingID, _, _, barValue, _, _, _, _ = GetFactionInfo(i)
        factionVars[name] = { }
        factionVars[name].Value = barValue
        factionVars[name].Standing = standingID
	end
	self:RegisterEvent("UPDATE_FACTION")
end
